<html>
<header>
<topic> </topic>
</header>
<body bgcolor=#ffffff>
<?php

################################################################################
#    PHP-RESIDENCE
#    Copyright (C) 2001 by Marco Maria Francesco De Santis (marcods@gmx.net)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
################################################################################

include("datipermanenti/connessione_db.inc");

// trovo il primo giorno di inizio/fine dell'anno
$numgiorno = 1;
do {
$nomegiorno = date("w",mktime(0,0,0,1,$numgiorno,$anno));
$numgiorno = $numgiorno + 1;
} while ($nomegiorno != $giorno_ini_fine) ;
$numgiorno  = $numgiorno - 1;

if ($mese_ini > $mese_fine) {
echo "I mesi erano indicati erroneamente, sono stati inseriti i mesi da Gennaio a Dicembre.<br>";
$mese_ini = 1;
$mese_fine = 12;
} # fine if ($mese_ini > $mese_fine)

$anno_fine = $anno + 1;

//creo la directory dell'anno
mkdir($anno, 0777);

// creo il file e la tabella con periodi settimanali e prezzi 
$tableperiodi = periodi . $anno;
pg_exec("create table $tableperiodi (idperiodi integer primary key, datainizio date not null, datafine date, tariffa1 integer, tariffa2 integer, tariffa3 integer, tariffa4 integer, tariffa5 integer, tariffa6 integer, tariffa7 integer, tariffa8 integer, tariffa9 integer, tariffa10 integer)");
$idperiodi = 1;
$fileaperto = fopen("$anno/selectperiodi.inc","a+");
fwrite($fileaperto,"<?php \necho \"\n");

do {
$datainizio = date("M d, Y" , mktime(0,0,0,1,$numgiorno,$anno));
$annocreato = date("Y" , mktime(0,0,0,1,$numgiorno,$anno));
$mesecreato = date("n" , mktime(0,0,0,1,$numgiorno,$anno));
$numgiorno = $numgiorno + 7;
$datafine = date("M d, Y" , mktime(0,0,0,1,$numgiorno,$anno));
$annocreato2 = date("Y" , mktime(0,0,0,1,$numgiorno,$anno));
$mesecreato2 = date("n" , mktime(0,0,0,1,$numgiorno,$anno));
if ($annocreato > $anno) {
$diff = $annocreato - $anno;
$mesecreato = ($diff * 12) + $mesecreato;
} # fine if ($annocreato > $anno)
if ($annocreato2 > $anno) {
$diff = $annocreato2 - $anno;
$mesecreato2 = ($diff * 12) + $mesecreato2;
} # fine if ($annocreato2 > $anno)
if ($mesecreato >= $mese_ini and $mesecreato <= $mese_fine) {
pg_exec("insert into $tableperiodi ( idperiodi, datainizio, datafine) values ( $idperiodi, '$datainizio', '$datafine')");
fwrite($fileaperto,"<option value=\\\"$datainizio\\\">$datainizio</option>
");
$idperiodi = $idperiodi + 1;
$datafine2 = $datafine;
} # fine if ($mesecreato >= $mese_ini and $mesecreato <= $mese_fine)
} while ($annocreato2 <= $anno_fine or $mesecreato2 == 25);


fwrite($fileaperto,"<option value=\\\"$datafine2\\\">$datafine2</option>
");
fwrite($fileaperto,"\"; \n?>");

# Inserisco l'anno nella tabella anni
pg_exec("insert into anni (idanni) values ($anno)");

# Creo la tabella con il nome delle tariffe
$tablenometariffe = ntariffe . $anno;
pg_exec("create table $tablenometariffe (idntariffe integer, tariffa1 varchar(40), tariffa2 varchar(40), tariffa3 varchar(40), tariffa4 varchar(40), tariffa5 varchar(40), tariffa6 varchar(40), tariffa7 varchar(40), tariffa8 varchar(40), tariffa9 varchar(40), tariffa10 varchar(40), costosettimanale integer, costofinale integer, costopercentuale integer, costop_arrotond integer, regole varchar(40), caparra_percent integer, caparra_arrotond float4 )");

# Creo la tabella delle prernotazioni
$tableprenotazioni = prenota . $anno;
pg_exec("create table $tableprenotazioni (idprenota integer primary key, idclienti integer, idappartamenti integer, iddatainizio integer, iddatafine integer, assegnazioneapp varchar(4), app_assegnabili text, num_persone integer, idprenota_compagna text, tariffa text, costiaggiuntivi text, sconto integer, tariffa_tot integer, caparra integer, pagato varchar(10), commento text, datainserimento datetime, hostinserimento varchar(50), data_modifica datetime )");

# Creo la tabella per le regole di assegnazione
$tableregole = regole . $anno;
pg_exec("create table $tableregole (idregole integer, app_agenzia integer, iddatainizio integer, iddatafine integer)");

# Creo la tabella con i costi di gestione
$tablecosti = costi . $anno;
pg_exec("create table $tablecosti (idcosti integer unique,nome_costo text, val_costo integer, persona_costo text, provenienza_costo text, tipo_costo text, datainserimento datetime, hostinserimento varchar(50))");
pg_exec("insert into $tablecosti (idcosti) values (0)");

# Importo eventuali prenotazioni, tariffe e regole dell'anno precedente
if ($importa_anno_prec == "SI") {
$anno_prec = $anno - 1;
$tablenometariffe_prec = ntariffe . $anno_prec;
$tableprenota = $tableprenotazioni;
$tableprenota_prec = prenota .$anno_prec;
$tableperiodi_prec = periodi . $anno_prec;
$tableregole_prec = regole . $anno_prec;
$data_inizio_periodi = pg_exec("select * from $tableperiodi where idperiodi = 1");
$data_inizio_periodi = pg_result($data_inizio_periodi,0,datainizio);
$ini_periodo_interferenza =  pg_exec("select * from $tableperiodi_prec where datainizio = '$data_inizio_periodi'");
$num_periodo_interferenza = pg_numrows($ini_periodo_interferenza);
if ($num_periodo_interferenza == 0) {
echo "Non ci sono periodi che riguardano il $anno nel $anno_prec, o il giorno di inizio/fine locazione era differente, sono stati importati solo i dati riguardanti costi aggiuntivi, caparra e nome delle tariffe.<br>";
} # fine if ($num_periodo_interferenza == 0)
else {
$id_data_fine_periodi = pg_exec("select max(idperiodi) from $tableperiodi");
$id_data_fine_periodi = pg_result($id_data_fine_periodi,0,max);
$id_data_ini_periodi_prec = pg_result($ini_periodo_interferenza,0,idperiodi);
$id_data_fine_periodi_prec = pg_exec("select max(idperiodi) from $tableperiodi_prec");
$id_data_fine_periodi_prec = pg_result($id_data_fine_periodi_prec,0,max);
$num_periodi_prec = $id_data_fine_periodi_prec - $id_data_ini_periodi_prec + 1;
if ($num_periodi_prec > $id_data_fine_periodi) {
$id_data_fine_periodi_prec = $id_data_ini_periodi_prec + $id_data_fine_periodi - 1;
$prenota_non_importabili = pg_exec("select * from $tableprenota_prec where iddatafine > $id_data_fine_periodi_prec ");
$num_prenota_non_importabili = pg_numrows($prenota_non_importabili);
if ($num_prenota_non_importabili != 0) {
echo "<font color=\"red\"><b>Attenzione</b></font>: i periodi del $anno_prec finivano dopo quelli del
 $anno e vi erano <b>$num_prenota_non_importabili</b> prenotazioni che finivano dopo il limite posto
 al $anno, queste prenotazioni non sono state importate.<br>";
} # fine if ($num_prenota_non_importabili != 0)
} # fine if ($num_periodi_prec > $id_data_fine_periodi)
pg_exec("insert into $tableprenota select * from $tableprenota_prec where iddatainizio >= '$id_data_ini_periodi_prec' and iddatafine <= '$id_data_fine_periodi_prec' ");
$prenota_importate = pg_exec("select * from $tableprenota_prec where iddatainizio >= '$id_data_ini_periodi_prec' and iddatafine <= '$id_data_fine_periodi_prec' order by idprenota ");
$num_prenota_importate = pg_numrows($prenota_importate);
for ($num1 = 0 ; $num1 < $num_prenota_importate ; $num1 = $num1 + 1) {
$idprenota = pg_result($prenota_importate,$num1,idprenota);
$iddatainizio = pg_result($prenota_importate,$num1,iddatainizio);
$iddatainizio = $iddatainizio - $id_data_ini_periodi_prec + 1;
$iddatafine = pg_result($prenota_importate,$num1,iddatafine);
$iddatafine = $iddatafine - $id_data_ini_periodi_prec + 1;
pg_exec("update $tableprenota set iddatainizio = '$iddatainizio' where idprenota = '$idprenota'");
pg_exec("update $tableprenota set iddatafine = '$iddatafine' where idprenota = '$idprenota'");
} # fine for $num1
$prenota_gia_iniziate = pg_exec("select * from $tableprenota_prec where iddatainizio < $id_data_ini_periodi_prec and iddatafine >= $id_data_ini_periodi_prec and iddatafine <= $id_data_fine_periodi_prec ");
$num_prenota_gia_iniziate = pg_numrows($prenota_gia_iniziate);
for ($num1 = 0 ; $num1 < $num_prenota_gia_iniziate ; $num1 = $num1 + 1) {
$idprenota = pg_result($prenota_gia_iniziate,$num1,idprenota);
$idclienti = pg_result($prenota_gia_iniziate,$num1,idclienti);
$idappartamenti = pg_result($prenota_gia_iniziate,$num1,idappartamenti);
$iddatafine = pg_result($prenota_gia_iniziate,$num1,iddatafine);
$iddatafine = $iddatafine - $id_data_ini_periodi_prec + 1;
$datainserimento = pg_result($prenota_gia_iniziate,$num1,datainserimento);
$hostinserimento = pg_result($prenota_gia_iniziate,$num1,hostinserimento);
$data_modifica = pg_result($prenota_gia_iniziate,$num1,data_modifica);
pg_exec("insert into $tableprenota (idprenota,idclienti,idappartamenti,iddatainizio,iddatafine,assegnazioneapp,datainserimento,hostinserimento) values ('$idprenota','$idclienti','$idappartamenti','0',$iddatafine,'k','$datainserimento','$hostinserimento') ");
} # fine for $num1
$tariffe_importate = pg_exec("select * from $tableperiodi_prec where ( tariffa1 != '' or  tariffa2 != '' or tariffa3 != '') and idperiodi >= '$id_data_ini_periodi_prec' and idperiodi <= '$id_data_fine_periodi_prec' ");
$num_tariffe_iportate = pg_numrows($tariffe_importate);
for ($num1 = 0 ; $num1 < $num_tariffe_iportate ; $num1 = $num1 + 1) {
$idperiodi = pg_result($tariffe_importate,$num1,idperiodi);
$idperiodi = $idperiodi - $id_data_ini_periodi_prec + 1;
$tariffa1 = pg_result($tariffe_importate,$num1,tariffa1);
$tariffa2 = pg_result($tariffe_importate,$num1,tariffa2);
$tariffa3 = pg_result($tariffe_importate,$num1,tariffa3);
if ($tariffa1) {
pg_exec("update $tableperiodi set tariffa1 = '$tariffa1' where idperiodi = $idperiodi ");
} # fine if ($tariffa1)
if ($tariffa2) {
pg_exec("update $tableperiodi set tariffa2 = '$tariffa2' where idperiodi = $idperiodi ");
} # fine if ($tariffa2)
if ($tariffa3) {
pg_exec("update $tableperiodi set tariffa3 = '$tariffa3' where idperiodi = $idperiodi ");
} # fine if ($tariffa3)
} # fine for $num1
$regole_prec = pg_exec("select * from $tableregole_prec where iddatafine >= '$id_data_ini_periodi_prec' ");
$num_regole_prec = pg_numrows($regole_prec);
for ($num1 = 0 ; $num1 < $num_regole_prec ; $num1 = $num1 + 1) {
$idregole = pg_result($regole_prec,$num1,idregole);
$app_agenzia = pg_result($regole_prec,$num1,app_agenzia);
$iddatainizio = pg_result($regole_prec,$num1,iddatainizio);
if ($iddatainizio < $id_data_ini_periodi_prec) { $iddatainizio = $id_data_ini_periodi_prec; }
$iddatainizio = $iddatainizio - $id_data_ini_periodi_prec + 1;
$iddatafine = pg_result($regole_prec,$num1,iddatafine);
if ($iddatafine > $id_data_fine_periodi_prec) { $iddatafine = $id_data_fine_periodi_prec; }
$iddatafine = $iddatafine - $id_data_ini_periodi_prec + 1;
pg_exec("insert into $tableregole (idregole,app_agenzia,iddatainizio,iddatafine) values ('$idregole','$app_agenzia','$iddatainizio','$iddatafine') ");
} # fine for $num1
} # fine else if ($num_periodo_interferenza == 0)
pg_exec("insert into $tablenometariffe select * from $tablenometariffe_prec");
$inserisci_in_ntariffe = "NO";
} # fine if ($importa_anno_prec == "SI")

if ($inserisci_in_ntariffe != "NO") {
# rigo 1: nomi tariffe; 2-4: costi finali; 5-7: costi settimanali; 8-10: costi percentuali.
for ($numtariffe =1 ; $numtariffe < 11 ; $numtariffe = $numtariffe + 1) {
pg_exec("insert into $tablenometariffe (idntariffe) values ($numtariffe)");
} # fine for $numtariffe
} # fine if ($inserisci_in_ntariffe != "NO")


?>

</body>
</html>
